gtkmm: Gdk::PixbufAnimationIter Class Reference

gtkmm 2.24.4

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Related Functions

# Gdk::PixbufAnimationIter Class Reference

An iterator which points to a certain position in a PixbufAnimation. More...

Inheritance diagram for Gdk::PixbufAnimationIter:
[legend]
Collaboration diagram for Gdk::PixbufAnimationIter:
[legend]

List of all members.

## Public Member Functions
virtual | ~PixbufAnimationIter ()
GdkPixbufAnimationIter* | gobj ()
| Provides access to the underlying C GObject.
const GdkPixbufAnimationIter* | gobj () const
| Provides access to the underlying C GObject.
GdkPixbufAnimationIter* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
int | get_delay_time () const
| Gets the number of milliseconds the current pixbuf should be displayed, or -1 if the current pixbuf should be displayed forever.
Glib::RefPtr< Gdk::Pixbuf > | get_pixbuf ()
| Gets the current pixbuf which should be displayed; the pixbuf will be the same size as the animation itself (Gdk::Pixbuf::get_width(), Gdk::Pixbuf:get_height()).
Glib::RefPtr< const Gdk::Pixbuf > | get_pixbuf () const
| Gets the current pixbuf which should be displayed; the pixbuf will be the same size as the animation itself (Gdk::Pixbuf::get_width(), Gdk::Pixbuf:get_height()).
bool | on_currently_loading_frame () const
| Used to determine how to respond to the area_updated signal on Gdk::PixbufLoader when loading an animation.
bool | advance (const Glib::TimeVal& current_time)
| Possibly advances an animation to a new frame.
bool | advance ()
| Possibly advances an animation to a new frame.
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gdk::PixbufAnimationIter > | wrap (GdkPixbufAnimationIter* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

An iterator which points to a certain position in a PixbufAnimation.

## Constructor & Destructor Documentation

virtual Gdk::PixbufAnimationIter::~PixbufAnimationIter | ( |  | ) | `[virtual]`

## Member Function Documentation

bool Gdk::PixbufAnimationIter::advance | ( | const Glib::TimeVal & | current_time | ) |

Possibly advances an animation to a new frame.

Chooses the frame based on the start time passed to Gdk::PixbufAnimation::get_iter().

current_time would normally come from Glib::get_current_time(), and must be greater than or equal to the time passed to Gdk::PixbufAnimation::get_iter(), and must increase or remain unchanged each time get_pixbuf() is called. That is, you can't go backward in time; animations only play forward.

If using the method overload that takes no current_time parameter then the current time will be used. So you only need to explicitly pass current_time if you're doing something odd like playing the animation at double speed.

If this function returns `false`, there's no need to update the animation display, assuming the display had been rendered prior to advancing; if `true`, you need to call get_pixbuf() and update the display with the new pixbuf.

Since gtkmm 2.14:

Parameters:

  current_time | Current time.

Returns:
  `true` if the image may need updating.

bool Gdk::PixbufAnimationIter::advance | ( |  | ) |

Possibly advances an animation to a new frame.

Chooses the frame based on the start time passed to Gdk::PixbufAnimation::get_iter().

If this function returns false, there's no need to update the animation display, assuming the display had been rendered prior to advancing; if true, you need to call get_pixbuf() and update the display with the new pixbuf.

Since gtkmm 2.14:

Returns:
  true if the image may need updating.

int Gdk::PixbufAnimationIter::get_delay_time | ( |  | ) | const

Gets the number of milliseconds the current pixbuf should be displayed, or -1 if the current pixbuf should be displayed forever.

Glib::signal_timeout.connect() conveniently takes a timeout in milliseconds, so you can use a timeout to schedule the next update.

Since gtkmm 2.14:

Returns:
  Delay time in milliseconds (thousandths of a second).

Glib::RefPtr<Gdk::Pixbuf> Gdk::PixbufAnimationIter::get_pixbuf | ( |  | ) |

Gets the current pixbuf which should be displayed; the pixbuf will be the same size as the animation itself (Gdk::Pixbuf::get_width(), Gdk::Pixbuf:get_height()).

This pixbuf should be displayed for get_delay_time() milliseconds. The returned pixbuf will become invalid when the iterator advances to the next frame, which may happen anytime you call advance(). Copy the pixbuf to keep it, with Gdk::Pixbuf::copy() as it may get recycled as you advance the iterator.

Since gtkmm 2.14:

Returns:
  The pixbuf to be displayed.

Glib::RefPtr<const Gdk::Pixbuf> Gdk::PixbufAnimationIter::get_pixbuf | ( |  | ) | const

Gets the current pixbuf which should be displayed; the pixbuf will be the same size as the animation itself (Gdk::Pixbuf::get_width(), Gdk::Pixbuf:get_height()).

This pixbuf should be displayed for get_delay_time() milliseconds. The returned pixbuf will become invalid when the iterator advances to the next frame, which may happen anytime you call advance(). Copy the pixbuf to keep it, with Gdk::Pixbuf::copy() as it may get recycled as you advance the iterator.

Since gtkmm 2.14:

Returns:
  The pixbuf to be displayed.

GdkPixbufAnimationIter* Gdk::PixbufAnimationIter::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

const GdkPixbufAnimationIter* Gdk::PixbufAnimationIter::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GdkPixbufAnimationIter* Gdk::PixbufAnimationIter::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gdk::PixbufAnimationIter::on_currently_loading_frame | ( |  | ) | const

Used to determine how to respond to the area_updated signal on Gdk::PixbufLoader when loading an animation.

The area_updated signal is emitted for an area of the frame currently streaming in to the loader. So if you're on the currently loading frame, you need to redraw the screen for the updated area.

Since gtkmm 2.14:

Returns:
  `true` if the frame we're on is partially loaded, or the last frame.

## Friends And Related Function Documentation

Glib::RefPtr< Gdk::PixbufAnimationIter > wrap | ( | GdkPixbufAnimationIter * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gdkmm/pixbufanimationiter.h